GDAL

- Main Page
- Related Pages
- Classes
- Files
- Download
- Issue Tracker

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
OGRCompoundCurve Class Reference

Utility class to store a collection of curves. More...

`#include <ogr_geometry.h>`

Inheritance diagram for OGRCompoundCurve:

## Public Member Functions
| OGRCompoundCurve ()
| Create an empty compound curve.
| OGRCompoundCurve (const OGRCompoundCurve &other)
| Copy constructor. More...
OGRCompoundCurve & | operator= (const OGRCompoundCurve &other)
| Assignment operator. More...
virtual int | WkbSize () const CPL_OVERRIDE
| Returns size of related binary representation. More...
virtual OGRErr | importFromWkb (unsigned char *, int=-1, OGRwkbVariant=wkbVariantOldOgc) CPL_OVERRIDE
| Assign geometry from well known binary data. More...
virtual OGRErr | exportToWkb (OGRwkbByteOrder, unsigned char *, OGRwkbVariant=wkbVariantOldOgc) const CPL_OVERRIDE
| Convert a geometry into well known binary format. More...
virtual OGRErr | importFromWkt (char **) CPL_OVERRIDE
| Assign geometry from well known text data. More...
virtual OGRErr | exportToWkt (char **ppszDstText, OGRwkbVariant=wkbVariantOldOgc) const CPL_OVERRIDE
| Convert a geometry into well known text format. More...
virtual OGRGeometry * | clone () const CPL_OVERRIDE
| Make a copy of this object. More...
virtual void | empty () CPL_OVERRIDE
| Clear geometry information. More...
virtual void | getEnvelope (OGREnvelope *psEnvelope) const CPL_OVERRIDE
| Computes and returns the bounding envelope for this geometry in the passed psEnvelope structure. More...
virtual void | getEnvelope (OGREnvelope3D *psEnvelope) const CPL_OVERRIDE
| Computes and returns the bounding envelope (3D) for this geometry in the passed psEnvelope structure. More...
virtual OGRBoolean | IsEmpty () const CPL_OVERRIDE
| Returns TRUE (non-zero) if the object has no points. More...
virtual double | get_Length () const CPL_OVERRIDE
| Returns the length of the curve. More...
virtual void | StartPoint (OGRPoint *) const CPL_OVERRIDE
| Return the curve start point. More...
virtual void | EndPoint (OGRPoint *) const CPL_OVERRIDE
| Return the curve end point. More...
virtual void | Value (double, OGRPoint *) const CPL_OVERRIDE
| Fetch point at given distance along curve. More...
virtual OGRLineString * | CurveToLine (double dfMaxAngleStepSizeDegrees=0, const char *const *papszOptions=NULL) const CPL_OVERRIDE
| Return a linestring from a curve geometry. More...
virtual int | getNumPoints () const CPL_OVERRIDE
| Return the number of points of a curve geometry. More...
virtual double | get_AreaOfCurveSegments () const CPL_OVERRIDE
| Return area of curve segments. More...
virtual double | get_Area () const CPL_OVERRIDE
| Get the area of the (closed) curve. More...
virtual OGRBoolean | Equals (OGRGeometry *) const CPL_OVERRIDE
| Returns TRUE if two geometries are equivalent. More...
int | getNumCurves () const
| Return the number of curves. More...
OGRCurve * | getCurve (int)
| Fetch reference to indicated internal ring. More...
const OGRCurve * | getCurve (int) const
| Fetch reference to indicated internal ring. More...
virtual void | setCoordinateDimension (int nDimension) CPL_OVERRIDE
| Set the coordinate dimension. More...
virtual void | set3D (OGRBoolean bIs3D) CPL_OVERRIDE
| Add or remove the Z coordinate dimension. More...
virtual void | setMeasured (OGRBoolean bIsMeasured) CPL_OVERRIDE
| Add or remove the M coordinate dimension. More...
OGRErr | addCurve (OGRCurve *, double dfToleranceEps=1e-14)
| Add a curve to the container. More...
OGRErr | addCurveDirectly (OGRCurve *, double dfToleranceEps=1e-14)
| Add a curve directly to the container. More...
OGRCurve * | stealCurve (int)
| "Steal" reference to curve. More...
virtual OGRPointIterator * | getPointIterator () const CPL_OVERRIDE
| Returns a point iterator over the curve. More...
virtual OGRwkbGeometryType | getGeometryType () const CPL_OVERRIDE
| Fetch geometry type. More...
virtual const char * | getGeometryName () const CPL_OVERRIDE
| Fetch WKT name for geometry type. More...
virtual OGRErr | transform (OGRCoordinateTransformation *poCT) CPL_OVERRIDE
| Apply arbitrary coordinate transformation to geometry. More...
virtual void | flattenTo2D () CPL_OVERRIDE
| Convert geometry to strictly 2D. More...
virtual void | segmentize (double dfMaxLength) CPL_OVERRIDE
| Modify the geometry such it has no segment longer then the given distance. More...
virtual OGRBoolean | hasCurveGeometry (int bLookForNonLinear=FALSE) const CPL_OVERRIDE
| Returns if this geometry is or has curve geometry. More...
virtual OGRGeometry * | getLinearGeometry (double dfMaxAngleStepSizeDegrees=0, const char *const *papszOptions=NULL) const CPL_OVERRIDE
| Return, possibly approximate, non-curve version of this geometry. More...
virtual void | swapXY () CPL_OVERRIDE
| Swap x and y coordinates. More...
Public Member Functions inherited from OGRCurve
virtual int | get_IsClosed () const
| Return TRUE if curve is closed. More...
virtual int | getDimension () const CPL_OVERRIDE
| Get the dimension of this object. More...
virtual OGRBoolean | IsConvex () const
| Returns if a (closed) curve forms a convex shape. More...
Public Member Functions inherited from OGRGeometry
| OGRGeometry (const OGRGeometry &other)
| Copy constructor. More...
OGRGeometry & | operator= (const OGRGeometry &other)
| Assignment operator. More...
virtual int | getCoordinateDimension () const
| Get the dimension of the coordinates in this object. More...
int | CoordinateDimension () const
| Get the dimension of the coordinates in this object. More...
virtual OGRBoolean | IsValid () const
| Test if the geometry is valid. More...
virtual OGRBoolean | IsSimple () const
| Test if the geometry is simple. More...
OGRBoolean | Is3D () const
OGRBoolean | IsMeasured () const
virtual OGRBoolean | IsRing () const
| Test if the geometry is a ring. More...
OGRwkbGeometryType | getIsoGeometryType () const
| Get the geometry type that conforms with ISO SQL/MM Part3. More...
virtual void | dumpReadable (FILE *, const char *=NULL, char **papszOptions=NULL) const
| Dump geometry in well known text format to indicated output file. More...
virtual char * | exportToGML (const char *const *papszOptions=NULL) const
| Convert a geometry into GML format. More...
virtual char * | exportToKML () const
| Convert a geometry into KML format. More...
virtual char * | exportToJson () const
| Convert a geometry into GeoJSON format. More...
virtual GEOSGeom | exportToGEOS (GEOSContextHandle_t hGEOSCtxt) const CPL_WARN_UNUSED_RESULT
| Returns a GEOSGeom object corresponding to the geometry. More...
virtual OGRGeometry * | getCurveGeometry (const char *const *papszOptions=NULL) const CPL_WARN_UNUSED_RESULT
| Return curve version of this geometry. More...
virtual void | closeRings ()
| Force rings to be closed. More...
void | assignSpatialReference (OGRSpatialReference *poSR)
| Assign spatial reference to this object. More...
OGRSpatialReference * | getSpatialReference (void) const
| Returns spatial reference system for object. More...
OGRErr | transformTo (OGRSpatialReference *poSR)
| Transform geometry to new spatial reference system. More...
virtual OGRBoolean | Intersects (const OGRGeometry *) const
| Do these features intersect? More...
virtual OGRBoolean | Disjoint (const OGRGeometry *) const
| Test for disjointness. More...
virtual OGRBoolean | Touches (const OGRGeometry *) const
| Test for touching. More...
virtual OGRBoolean | Crosses (const OGRGeometry *) const
| Test for crossing. More...
virtual OGRBoolean | Within (const OGRGeometry *) const
| Test for containment. More...
virtual OGRBoolean | Contains (const OGRGeometry *) const
| Test for containment. More...
virtual OGRBoolean | Overlaps (const OGRGeometry *) const
| Test for overlap. More...
virtual OGRGeometry * | Boundary () const CPL_WARN_UNUSED_RESULT
| Compute boundary. More...
virtual double | Distance (const OGRGeometry *) const
| Compute distance between two geometries. More...
virtual OGRGeometry * | ConvexHull () const CPL_WARN_UNUSED_RESULT
| Compute convex hull. More...
virtual OGRGeometry * | Buffer (double dfDist, int nQuadSegs=30) const CPL_WARN_UNUSED_RESULT
| Compute buffer of geometry. More...
virtual OGRGeometry * | Intersection (const OGRGeometry *) const CPL_WARN_UNUSED_RESULT
| Compute intersection. More...
virtual OGRGeometry * | Union (const OGRGeometry *) const CPL_WARN_UNUSED_RESULT
| Compute union. More...
virtual OGRGeometry * | UnionCascaded () const CPL_WARN_UNUSED_RESULT
| Compute union using cascading. More...
virtual OGRGeometry * | Difference (const OGRGeometry *) const CPL_WARN_UNUSED_RESULT
| Compute difference. More...
virtual OGRGeometry * | SymDifference (const OGRGeometry *) const CPL_WARN_UNUSED_RESULT
| Compute symmetric difference. More...
virtual OGRErr | Centroid (OGRPoint *poPoint) const
| Compute the geometry centroid. More...
virtual OGRGeometry * | Simplify (double dTolerance) const CPL_WARN_UNUSED_RESULT
| Simplify the geometry. More...
OGRGeometry * | SimplifyPreserveTopology (double dTolerance) const CPL_WARN_UNUSED_RESULT
| Simplify the geometry while preserving topology. More...
virtual OGRGeometry * | DelaunayTriangulation (double dfTolerance, int bOnlyEdges) const CPL_WARN_UNUSED_RESULT
| Return a Delaunay triangulation of the vertices of the geometry. More...
virtual OGRGeometry * | Polygonize () const CPL_WARN_UNUSED_RESULT
| Polygonizes a set of sparse edges. More...
virtual double | Distance3D (const OGRGeometry *poOtherGeom) const
| Returns the 3D distance between two geometries. More...

## Additional Inherited Members
Static Public Member Functions inherited from OGRCurve
static OGRCompoundCurve * | CastToCompoundCurve (OGRCurve *puCurve)
| Cast to compound curve. More...
static OGRLineString * | CastToLineString (OGRCurve *poCurve)
| Cast to linestring. More...
static OGRLinearRing * | CastToLinearRing (OGRCurve *poCurve)
| Cast to linear ring. More...
Static Public Member Functions inherited from OGRGeometry
static GEOSContextHandle_t | createGEOSContext ()
| Create a new GEOS context. More...
static void | freeGEOSContext (GEOSContextHandle_t hGEOSCtxt)
| Destroy a GEOS context. More...
Protected Member Functions inherited from OGRCurve
virtual int | ContainsPoint (const OGRPoint *p) const
| Returns if a point is contained in a (closed) curve. More...

## Detailed Description

Utility class to store a collection of curves.

Used as a member of OGRCompoundCurve and OGRCurvePolygon.

This class is only exported because of linking issues. It should never be directly used.

Since
  GDAL 2.0 Concrete representation of a compound curve, made of curves: OGRLineString and OGRCircularString. Each curve is connected by its first point to the last point of the previous curve.

Compatibility: ISO SQL/MM Part 3.

Since
  GDAL 2.0

## Constructor & Destructor Documentation

OGRCompoundCurve::OGRCompoundCurve | ( | const OGRCompoundCurve & | other | ) |

Copy constructor.

Note: before GDAL 2.1, only the default implementation of the constructor existed, which could be unsafe to use.

Since
  GDAL 2.1

## Member Function Documentation

OGRErr OGRCompoundCurve::addCurve | ( | OGRCurve * | poCurve,
|  | double | dfToleranceEps = `1e-14`
| ) |  |

Add a curve to the container.

The passed geometry is cloned to make an internal copy.

There is no ISO SQL/MM analog to this method.

This method is the same as the C function OGR_G_AddGeometry().

Parameters

  poCurve | geometry to add to the container.
  dfToleranceEps | tolerance when checking that the first point of a segment matches then end point of the previous one. Default value: 1e-14.

Returns
  OGRERR_NONE if successful, or OGRERR_FAILURE in case of error (for example if curves are not contiguous)

OGRErr OGRCompoundCurve::addCurveDirectly | ( | OGRCurve * | poCurve,
|  | double | dfToleranceEps = `1e-14`
| ) |  |

Add a curve directly to the container.

Ownership of the passed geometry is taken by the container rather than cloning as addCurve() does.

There is no ISO SQL/MM analog to this method.

This method is the same as the C function OGR_G_AddGeometryDirectly().

Parameters

  poCurve | geometry to add to the container.
  dfToleranceEps | tolerance when checking that the first point of a segment matches then end point of the previous one. Default value: 1e-14.

Returns
  OGRERR_NONE if successful, or OGRERR_FAILURE in case of error (for example if curves are not contiguous)

OGRGeometry * OGRCompoundCurve::clone | ( |  | ) | const
| virtual

Make a copy of this object.

This method relates to the SFCOM IGeometry::clone() method.

This method is the same as the C function OGR_G_Clone().

Returns
  a new object instance with the same geometry, and spatial reference system as the original.

Implements OGRGeometry.

OGRLineString * OGRCompoundCurve::CurveToLine | ( | double | dfMaxAngleStepSizeDegrees = `0`,
|  | const char *const * | papszOptions = `NULL`
| ) |  | const
| virtual

Return a linestring from a curve geometry.

The returned geometry is a new instance whose ownership belongs to the caller.

If the dfMaxAngleStepSizeDegrees is zero, then a default value will be used. This is currently 4 degrees unless the user has overridden the value with the OGR_ARC_STEPSIZE configuration variable.

This method relates to the ISO SQL/MM Part 3 ICurve::CurveToLine() method.

This function is the same as C function OGR_G_CurveToLine().

Parameters

  dfMaxAngleStepSizeDegrees | the largest step in degrees along the arc, zero to use the default setting.
  papszOptions | options as a null-terminated list of strings or NULL. See OGRGeometryFactory::curveToLineString() for valid options.

Returns
  a line string approximating the curve

Since
  GDAL 2.0

Implements OGRCurve.

void OGRCompoundCurve::empty | ( |  | ) |
| virtual

Clear geometry information.

This restores the geometry to it's initial state after construction, and before assignment of actual geometry.

This method relates to the SFCOM IGeometry::Empty() method.

This method is the same as the C function OGR_G_Empty().

Implements OGRGeometry.

void OGRCompoundCurve::EndPoint | ( | OGRPoint * | poPoint | ) | const
| virtual

Return the curve end point.

This method relates to the SF COM ICurve::get_EndPoint() method.

Parameters

  poPoint | the point to be assigned the end location.

Implements OGRCurve.

OGRBoolean OGRCompoundCurve::Equals | ( | OGRGeometry * | poOtherGeom | ) | const
| virtual

Returns TRUE if two geometries are equivalent.

This operation implements the SQL/MM ST_OrderingEquals() operation.

The comparison is done in a structural way, that is to say that the geometry types must be identical, as well as the number and ordering of sub-geometries and vertices. Or equivalently, two geometries are considered equal by this method if their WKT/WKB representation is equal. Note: this must be distinguished for equality in a spatial way (which is the purpose of the ST_Equals() operation).

This method is the same as the C function OGR_G_Equals().

Returns
  TRUE if equivalent or FALSE otherwise.

Implements OGRGeometry.

OGRErr OGRCompoundCurve::exportToWkb | ( | OGRwkbByteOrder | eByteOrder,
|  | unsigned char * | pabyData,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOldOgc`
| ) |  | const
| virtual

Convert a geometry into well known binary format.

This method relates to the SFCOM IWks::ExportToWKB() method.

This method is the same as the C function OGR_G_ExportToWkb() or OGR_G_ExportToIsoWkb(), depending on the value of eWkbVariant.

Parameters

  eByteOrder | One of wkbXDR or wkbNDR indicating MSB or LSB byte order respectively.
  pabyData | a buffer into which the binary representation is written. This buffer must be at least OGRGeometry::WkbSize() byte in size.
  eWkbVariant | What standard to use when exporting geometries with three dimensions (or more). The default wkbVariantOldOgc is the historical OGR variant. wkbVariantIso is the variant defined in ISO SQL/MM and adopted by OGC for SFSQL 1.2.

Returns
  Currently OGRERR_NONE is always returned.

Implements OGRGeometry.

OGRErr OGRCompoundCurve::exportToWkt | ( | char ** | ppszDstText,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOldOgc`
| ) |  | const
| virtual

Convert a geometry into well known text format.

This method relates to the SFCOM IWks::ExportToWKT() method.

This method is the same as the C function OGR_G_ExportToWkt().

Parameters

  ppszDstText | a text buffer is allocated by the program, and assigned to the passed pointer. After use, *ppszDstText should be freed with CPLFree().
  eWkbVariant | the specification that must be conformed too : wbkVariantOgc for old-style 99-402 extended dimension (Z) WKB types wbkVariantIso for SFSQL 1.2 and ISO SQL/MM Part 3

Returns
  Currently OGRERR_NONE is always returned.

Implements OGRGeometry.

void OGRCompoundCurve::flattenTo2D | ( |  | ) |
| virtual

Convert geometry to strictly 2D.

In a sense this converts all Z coordinates to 0.0.

This method is the same as the C function OGR_G_FlattenTo2D().

Implements OGRGeometry.

double OGRCompoundCurve::get_Area | ( |  | ) | const
| virtual

Get the area of the (closed) curve.

This method is designed to be used by OGRCurvePolygon::get_Area().

Returns
  the area of the feature in square units of the spatial reference system in use.

Since
  GDAL 2.0

Implements OGRCurve.

double OGRCompoundCurve::get_AreaOfCurveSegments | ( |  | ) | const
| virtual

Return area of curve segments.

Returns
  area.

Implements OGRCurve.

double OGRCompoundCurve::get_Length | ( |  | ) | const
| virtual

Returns the length of the curve.

This method relates to the SFCOM ICurve::get_Length() method.

Returns
  the length of the curve, zero if the curve hasn't been initialized.

Implements OGRCurve.

OGRCurve * OGRCompoundCurve::getCurve | ( | int | iRing | ) |

Fetch reference to indicated internal ring.

Note that the returned curve pointer is to an internal data object of the OGRCompoundCurve. It should not be modified or deleted by the application, and the pointer is only valid till the polygon is next modified. Use the OGRGeometry::clone() method to make a separate copy within the application.

Relates to the ISO SQL/MM ST_CurveN() function.

Parameters

  iRing | curve index from 0 to getNumCurves() - 1.

Returns
  pointer to curve. May be NULL.

const OGRCurve * OGRCompoundCurve::getCurve | ( | int | iCurve | ) | const

Fetch reference to indicated internal ring.

Note that the returned curve pointer is to an internal data object of the OGRCompoundCurve. It should not be modified or deleted by the application, and the pointer is only valid till the polygon is next modified. Use the OGRGeometry::clone() method to make a separate copy within the application.

Relates to the ISO SQL/MM ST_CurveN() function.

Parameters

  iCurve | curve index from 0 to getNumCurves() - 1.

Returns
  pointer to curve. May be NULL.

void OGRCompoundCurve::getEnvelope | ( | OGREnvelope * | psEnvelope | ) | const
| virtual

Computes and returns the bounding envelope for this geometry in the passed psEnvelope structure.

This method is the same as the C function OGR_G_GetEnvelope().

Parameters

  psEnvelope | the structure in which to place the results.

Implements OGRGeometry.

void OGRCompoundCurve::getEnvelope | ( | OGREnvelope3D * | psEnvelope | ) | const
| virtual

Computes and returns the bounding envelope (3D) for this geometry in the passed psEnvelope structure.

This method is the same as the C function OGR_G_GetEnvelope3D().

Parameters

  psEnvelope | the structure in which to place the results.

Since
  OGR 1.9.0

Implements OGRGeometry.

const char * OGRCompoundCurve::getGeometryName | ( |  | ) | const
| virtual

Fetch WKT name for geometry type.

There is no SFCOM analog to this method.

This method is the same as the C function OGR_G_GetGeometryName().

Returns
  name used for this geometry type in well known text format. The returned pointer is to a static internal string and should not be modified or freed.

Implements OGRGeometry.

OGRwkbGeometryType OGRCompoundCurve::getGeometryType | ( |  | ) | const
| virtual

Fetch geometry type.

Note that the geometry type may include the 2.5D flag. To get a 2D flattened version of the geometry type apply the wkbFlatten() macro to the return result.

This method is the same as the C function OGR_G_GetGeometryType().

Returns
  the geometry type code.

Implements OGRGeometry.

OGRGeometry * OGRCompoundCurve::getLinearGeometry | ( | double | dfMaxAngleStepSizeDegrees = `0`,
|  | const char *const * | papszOptions = `NULL`
| ) |  | const
| virtual

Return, possibly approximate, non-curve version of this geometry.

Returns a geometry that has no CIRCULARSTRING, COMPOUNDCURVE, CURVEPOLYGON, MULTICURVE or MULTISURFACE in it, by approximating curve geometries.

The ownership of the returned geometry belongs to the caller.

The reverse method is OGRGeometry::getCurveGeometry().

This method is the same as the C function OGR_G_GetLinearGeometry().

Parameters

  dfMaxAngleStepSizeDegrees | the largest step in degrees along the arc, zero to use the default setting.
  papszOptions | options as a null-terminated list of strings. See OGRGeometryFactory::curveToLineString() for valid options.

Returns
  a new geometry.

Since
  GDAL 2.0

Reimplemented from OGRGeometry.

int OGRCompoundCurve::getNumCurves | ( |  | ) | const

Return the number of curves.

Note that the number of curves making this compound curve.

Relates to the ISO SQL/MM ST_NumCurves() function.

Returns
  number of curves.

int OGRCompoundCurve::getNumPoints | ( |  | ) | const
| virtual

Return the number of points of a curve geometry.

This method, as a method of OGRCurve, does not relate to a standard. For circular strings or linestrings, it returns the number of points, conforming to SF COM NumPoints(). For compound curves, it returns the sum of the number of points of each of its components (non including intermediate starting/ending points of the different parts).

Returns
  the number of points of the curve.

Since
  GDAL 2.0

Implements OGRCurve.

OGRPointIterator * OGRCompoundCurve::getPointIterator | ( |  | ) | const
| virtual

Returns a point iterator over the curve.

The curve must not be modified while an iterator exists on it.

The iterator must be destroyed with OGRPointIterator::destroy().

Returns
  a point iterator over the curve.

Since
  GDAL 2.0

Implements OGRCurve.

OGRBoolean OGRCompoundCurve::hasCurveGeometry | ( | int | bLookForNonLinear = `FALSE` | ) | const
| virtual

Returns if this geometry is or has curve geometry.

Returns if a geometry is, contains or may contain a CIRCULARSTRING, COMPOUNDCURVE, CURVEPOLYGON, MULTICURVE or MULTISURFACE.

If bLookForNonLinear is set to TRUE, it will be actually looked if the geometry or its subgeometries are or contain a non-linear geometry in them. In which case, if the method returns TRUE, it means that getLinearGeometry() would return an approximate version of the geometry. Otherwise, getLinearGeometry() would do a conversion, but with just converting container type, like COMPOUNDCURVE -> LINESTRING, MULTICURVE -> MULTILINESTRING or MULTISURFACE -> MULTIPOLYGON, resulting in a "loss-less" conversion.

This method is the same as the C function OGR_G_HasCurveGeometry().

Parameters

  bLookForNonLinear | set it to TRUE to check if the geometry is or contains a CIRCULARSTRING.

Returns
  TRUE if this geometry is or has curve geometry.

Since
  GDAL 2.0

Reimplemented from OGRGeometry.

OGRErr OGRCompoundCurve::importFromWkb | ( | unsigned char * | pabyData,
|  | int | nSize = `-1`,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOldOgc`
| ) |  |
| virtual

Assign geometry from well known binary data.

The object must have already been instantiated as the correct derived type of geometry object to match the binaries type. This method is used by the OGRGeometryFactory class, but not normally called by application code.

This method relates to the SFCOM IWks::ImportFromWKB() method.

This method is the same as the C function OGR_G_ImportFromWkb().

Parameters

  pabyData | the binary input data.
  nSize | the size of pabyData in bytes, or zero if not known.
  eWkbVariant | if wkbVariantPostGIS1, special interpretation is done for curve geometries code

Returns
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

Implements OGRGeometry.

OGRErr OGRCompoundCurve::importFromWkt | ( | char ** | ppszInput | ) |
| virtual

Assign geometry from well known text data.

The object must have already been instantiated as the correct derived type of geometry object to match the text type. This method is used by the OGRGeometryFactory class, but not normally called by application code.

This method relates to the SFCOM IWks::ImportFromWKT() method.

This method is the same as the C function OGR_G_ImportFromWkt().

Parameters

  ppszInput | pointer to a pointer to the source text. The pointer is updated to pointer after the consumed text.

Returns
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

Implements OGRGeometry.

OGRBoolean OGRCompoundCurve::IsEmpty | ( |  | ) | const
| virtual

Returns TRUE (non-zero) if the object has no points.

Normally this returns FALSE except between when an object is instantiated and points have been assigned.

This method relates to the SFCOM IGeometry::IsEmpty() method.

Returns
  TRUE if object is empty, otherwise FALSE.

Implements OGRGeometry.

OGRCompoundCurve & OGRCompoundCurve::operator= | ( | const OGRCompoundCurve & | other | ) |

Assignment operator.

Note: before GDAL 2.1, only the default implementation of the operator existed, which could be unsafe to use.

Since
  GDAL 2.1

void OGRCompoundCurve::segmentize | ( | double | dfMaxLength | ) |
| virtual

Modify the geometry such it has no segment longer then the given distance.

Add intermediate vertices to a geometry.

Interpolated points will have Z and M values (if needed) set to 0. Distance computation is performed in 2d only

This function is the same as the C function OGR_G_Segmentize()

Parameters

  dfMaxLength | the maximum distance between 2 points after segmentization

This method modifies the geometry to add intermediate vertices if necessary so that the maximum length between 2 consecutive vertices is lower than dfMaxLength.

Parameters

  dfMaxLength | maximum length between 2 consecutive vertices.

Reimplemented from OGRGeometry.

void OGRCompoundCurve::set3D | ( | OGRBoolean | bIs3D | ) |
| virtual

Add or remove the Z coordinate dimension.

This method adds or removes the explicit Z coordinate dimension. Removing the Z coordinate dimension of a geometry will remove any existing Z values. Adding the Z dimension to a geometry collection, a compound curve, a polygon, etc. will affect the children geometries.

Parameters

  bIs3D | Should the geometry have a Z dimension, either TRUE or FALSE.

Since
  GDAL 2.1

Reimplemented from OGRGeometry.

void OGRCompoundCurve::setCoordinateDimension | ( | int | nNewDimension | ) |
| virtual

Set the coordinate dimension.

This method sets the explicit coordinate dimension. Setting the coordinate dimension of a geometry to 2 should zero out any existing Z values. Setting the dimension of a geometry collection, a compound curve, a polygon, etc. will affect the children geometries. This will also remove the M dimension if present before this call.

Deprecated:
  use set3D() or setMeasured().

Parameters

  nNewDimension | New coordinate dimension value, either 2 or 3.

Reimplemented from OGRGeometry.

void OGRCompoundCurve::setMeasured | ( | OGRBoolean | bIsMeasured | ) |
| virtual

Add or remove the M coordinate dimension.

This method adds or removes the explicit M coordinate dimension. Removing the M coordinate dimension of a geometry will remove any existing M values. Adding the M dimension to a geometry collection, a compound curve, a polygon, etc. will affect the children geometries.

Parameters

  bIsMeasured | Should the geometry have a M dimension, either TRUE or FALSE.

Since
  GDAL 2.1

Reimplemented from OGRGeometry.

void OGRCompoundCurve::StartPoint | ( | OGRPoint * | poPoint | ) | const
| virtual

Return the curve start point.

This method relates to the SF COM ICurve::get_StartPoint() method.

Parameters

  poPoint | the point to be assigned the start location.

Implements OGRCurve.

OGRCurve * OGRCompoundCurve::stealCurve | ( | int | iCurve | ) |

"Steal" reference to curve.

Parameters

  iCurve | curve index from 0 to getNumCurves() - 1.

Returns
  pointer to curve. May be NULL.

void OGRCompoundCurve::swapXY | ( |  | ) |
| virtual

Swap x and y coordinates.

Since
  OGR 1.8.0

Reimplemented from OGRGeometry.

OGRErr OGRCompoundCurve::transform | ( | OGRCoordinateTransformation * | poCT | ) |
| virtual

Apply arbitrary coordinate transformation to geometry.

This method will transform the coordinates of a geometry from their current spatial reference system to a new target spatial reference system. Normally this means reprojecting the vectors, but it could include datum shifts, and changes of units.

Note that this method does not require that the geometry already have a spatial reference system. It will be assumed that they can be treated as having the source spatial reference system of the OGRCoordinateTransformation object, and the actual SRS of the geometry will be ignored. On successful completion the output OGRSpatialReference of the OGRCoordinateTransformation will be assigned to the geometry.

This method is the same as the C function OGR_G_Transform().

Parameters

  poCT | the transformation to apply.

Returns
  OGRERR_NONE on success or an error code.

Implements OGRGeometry.

void OGRCompoundCurve::Value | ( | double | dfDistance,
|  | OGRPoint * | poPoint
| ) |  | const
| virtual

Fetch point at given distance along curve.

This method relates to the SF COM ICurve::get_Value() method.

This function is the same as the C function OGR_G_Value().

Parameters

  dfDistance | distance along the curve at which to sample position. This distance should be between zero and get_Length() for this curve.
  poPoint | the point to be assigned the curve position.

Implements OGRCurve.

int OGRCompoundCurve::WkbSize | ( |  | ) | const
| virtual

Returns size of related binary representation.

This method returns the exact number of bytes required to hold the well known binary representation of this geometry object. Its computation may be slightly expensive for complex geometries.

This method relates to the SFCOM IWks::WkbSize() method.

This method is the same as the C function OGR_G_WkbSize().

Returns
  size of binary representation in bytes.

Implements OGRGeometry.

The documentation for this class was generated from the following files:

- ogr_geometry.h
- ogrcompoundcurve.cpp

Generated for GDAL by 1.8.8.